#include "q3la.h"

char td_string[256] = "<td>";

void html::html_header(outputfile* out)
{
	out->write ("<html>\r\n");
	out->write ("<center>\r\n");
	out->write ("<body bgcolor=\"#000000\" text=\"#FFFFFF\">\r\n");
	out->write ("<font face=\"Arial\">\r\n");
}

void html::html_footer(outputfile* out, bool output_legend)
{
	if (output_legend == true) {
		legend(out);
	}
	line_header(out);
	out->write ("<font size=\"2\"><a href=\"http://www.planetquake.com/idda/\">");
	out->write ("<font color=\"#FF0000\">Q3LA</font></a> %s, %s", version, date);
	out->write (" by <a href=\"mailto:spike@planetquake.com\">");
	out->write ("<font color=\"#FFFFFF\">Fabian Huester</font></font>");
	line_footer(out);
	out->write ("</font>");
	out->write ("</body>\r\n");
	out->write ("</center>\r\n");
	out->write ("</html>\r\n");
}

void html::legend(outputfile* out) 
{
	line_header(out);
	out->write ("<b>Ratio</b> is calculated as (FPM / DPM)");
	out->write ("<br><b>Eff</b> is calculated as (100 * kills / (kills + total deaths))");
	out->write ("<br><b>Skill</b> is calculated as (kills / (total deaths + 1))");
	out->write ("<br><b>MKIOL</b> means \"Most Kills In One Life\"");
	out->write ("<br><b>FPM</b> is Frags Per Minute");
	out->write ("<br><b>DPM</b> is total Deaths Per Minute");
	out->write ("<br><b>Total deaths</b> is (killed + suicides + deaths)");
	line_footer(out);
}

void html::table_header(outputfile* out, char* formatstring)
{
	out->write ("\r\n<table %s>\r\n", formatstring);
}

void html::table_footer(outputfile* out)
{
	out->write ("</table>\r\n");
}

void html::table_entry(outputfile* out, char* formatstring, ...)
{
	va_list arglist;
	static char tempstr[1024];
	va_start (arglist, formatstring);
	vsprintf (tempstr, formatstring, arglist);
	out->write ("%s%s</td>\r\n", td_string, tempstr);
}

void html::table_entry_bold(outputfile* out, char* formatstring, ...)
{
	va_list arglist;
	static char tempstr[1024];
	va_start (arglist, formatstring);
	vsprintf (tempstr, formatstring, arglist);
	out->write ("%s<b>%s</b></td>\r\n", td_string, tempstr);
}

void html::line(outputfile* out, char* formatstring, ...)
{
	va_list arglist;
	char tempstr[1024];
	va_start (arglist, formatstring);
	vsprintf (tempstr, formatstring, arglist);

	line_header(out);
	out->write ("%s", tempstr);
	line_footer(out);
}

void html::line_header(outputfile* out)
{
	out->write ("<p>");
}

void html::line_footer(outputfile* out)
{
	out->write ("</p>");
}

void html::set_td(char* td_in)
{
	strcpy (td_string, td_in);
}
